include masm32rt.inc

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

IDT_CHECK_CAPSLOCK EQU 100

.data?
    hInstance   HINSTANCE   ?
    pOrgProc   PVOID      ?
    capslock   DWORD      ?
.code
main proc
LOCAL msg:MSG

    mov hInstance,rv(GetModuleHandle,0)
    
    ; our main-window
    mov edi,rv(CreateWindowEx,0,"MDICLIENT",0,WS_VISIBLE or WS_SYSMENU,100,100,100,50,0,0,hInstance,0)
    mov pOrgProc,rv(GetWindowLong,edi,GWL_WNDPROC)
    invoke SetWindowLong,edi,GWL_WNDPROC,WndProc
     
    ; edit control
    mov esi,rv(CreateWindowEx,0,"EDIT",0,WS_VISIBLE or WS_CHILD,0,0,100,50,edi,0,hInstance,0)
    
    ; create timer
    invoke SetTimer,edi,IDT_CHECK_CAPSLOCK,25,0
    
    .while 1
        invoke GetMessage,ADDR msg,0,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg      
    .endw
    
    exit
    
main endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    .if uMsg == WM_CLOSE
        invoke PostQuitMessage,0
    .elseif uMsg == WM_CTLCOLOREDIT
        .if capslock
            invoke SetBkColor,wParam,07171FFh
            invoke CreateSolidBrush,07171FFh
        .else
            invoke SetBkColor,wParam,0ffffffh
            invoke CreateSolidBrush,0ffffffh
        .endif
        ret
    .elseif uMsg == WM_TIMER
        .if wParam == IDT_CHECK_CAPSLOCK
            mov edx,rv(GetKeyState,VK_CAPITAL)
            .if  edx & 1 && !capslock
                mov capslock,1
                invoke InvalidateRect,hWnd,0,TRUE
            .elseif !(edx & 1) && capslock
                mov capslock,0
                invoke InvalidateRect,hWnd,0,TRUE
            .endif
        .else   
@@:         jmp @F
        .endif
    .else
@@:      invoke CallWindowProc,pOrgProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret
    
WndProc endp
end main